package com.ggreiff.gel.tag.javascript;

import org.apache.commons.jelly.*;
import org.apache.commons.jelly.tags.core.ArgTagParent;
import org.apache.commons.jelly.tags.core.BaseClassLoaderTag;

/**
 * Created with IntelliJ IDEA.
 * User: ggreiff
 * Date: 8/20/14
 * Time: 5:55 PM
 */
public class FunctionsScriptTag extends BaseClassLoaderTag {

    private String functionScript;

    private String kassType;

    public FunctionsScriptTag() {kassType = "com.ggreiff.gel.tag.javascript.ScriptType";}

    public void doTag(XMLOutput xmlOutput) throws MissingAttributeException, JellyTagException {

        this.functionScript = getBodyText();

        if (this.functionScript != null || this.functionScript.length() > 0) {

            Class klass = null;
            ScriptType scriptType = new ScriptType(ScriptPart.FUNCTION, this.functionScript);
            try {
                klass = getClassLoader().loadClass(kassType);
            } catch (ClassNotFoundException e) {
                throw new JellyTagException(e);
            }

            ArgTagParent parent = (ArgTagParent) findAncestorWithClass(ArgTagParent.class);
            if (null == parent) {
                throw new JellyTagException("This tag must be enclosed inside an ArgTagParent implementation (for example, <new> or <invoke>)");
            }
            parent.addArgument(klass, scriptType);
        }
    }
}

