package com.ggreiff.gel.tag.javascript;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

/**
 * Created with IntelliJ IDEA.
 * User: ggreiff
 * Date: 8/19/14
 * Time: 3:34 PM
 */
public class JsContextMap {

    private final Map<String, JsValue> jsValueMap;

    public JsContextMap() {
        jsValueMap = new HashMap<String, JsValue>();
    }

    public JsValue getJSValue(String name) {
        return jsValueMap.get(name);
    }

    public void putJsValue(String name, JsValue value) {
        jsValueMap.put(name, value);
    }

    public List<JsVariable> getJsVariables() {
        List<JsVariable> variables = new ArrayList(jsValueMap.size());

        for (Entry<String, JsValue> entry : jsValueMap.entrySet()) {
            String varName = entry.getKey();
            JsValue varValue = entry.getValue();
            JsVariable variable = new JsVariable(varName, varValue);
            variables.add(variable);
        }

        return variables;
    }
}