package com.ggreiff.gel.tag.javascript;

import org.apache.commons.jelly.JellyTagException;
import org.apache.commons.jelly.MissingAttributeException;
import org.apache.commons.jelly.XMLOutput;
import org.apache.commons.jelly.tags.core.ArgTagParent;
import org.apache.commons.jelly.tags.core.BaseClassLoaderTag;

/**
 * Created with IntelliJ IDEA.
 * User: ggreiff
 * Date: 8/20/14
 * Time: 6:07 PM
 */
public class MainScriptTag extends BaseClassLoaderTag {

    private String mainScript;

    private String kassType;

    public MainScriptTag() {kassType = "com.ggreiff.gel.tag.javascript.ScriptType";}


    public void doTag(XMLOutput xmlOutput) throws JellyTagException {

        this.mainScript = getBodyText();

        if (this.mainScript != null && this.mainScript.length() > 0) {
            Class klass;
            ScriptType scriptType = new ScriptType(ScriptPart.MAIN, this.mainScript);

            try {
                klass = getClassLoader().loadClass(kassType);
            } catch (ClassNotFoundException e) {
                throw new JellyTagException(e);
            }

            ArgTagParent parent = (ArgTagParent) findAncestorWithClass(ArgTagParent.class);
            if (null == parent) {
                throw new JellyTagException("This tag must be enclosed inside an ArgTagParent implementation (for example, <new> or <invoke>)");
            }
            parent.addArgument(klass, scriptType);
        }
    }
}