package com.ggreiff.gel.tag.xls;

import org.apache.commons.jelly.JellyTagException;
import org.apache.commons.jelly.MissingAttributeException;
import org.apache.commons.jelly.TagSupport;
import org.apache.commons.jelly.XMLOutput;
import org.apache.commons.jelly.tags.Resources;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

/**
 * Created with IntelliJ IDEA.
 * User: ggreiff
 * Date: 3/9/14
 * Time: 12:30 PM
 */

public class XlsOpenTag extends TagSupport
{
    private static final Log log = LogFactory.getLog(XlsOpenTag.class);

    private String _var = "";
    private String _fileName = "";
    private HSSFWorkbook _hssfWorkBook;


    public XlsOpenTag() {}

    public void doTag(XMLOutput output) throws JellyTagException
    {
        if (this._fileName.isEmpty())
        {
            this._hssfWorkBook = new HSSFWorkbook();
        }
        else {

            File f = new File(this._fileName);
            if(!f.exists() || f.isDirectory()){
                log.error("Could not load xls file");
                throw new JellyTagException("Unable to load the xls file");
            }
            try {
            InputStream existingXls = new FileInputStream(this._fileName);
                this._hssfWorkBook = new HSSFWorkbook(existingXls);
            } catch (Exception ex){
                log.error("Could not load xls file");
                throw new JellyTagException("Unable to load the xls file\n" + ex.getMessage());
            }
            this.context.setVariable("com.ggreiff.gel.tag.xls.XlsOpenTag.fileName",this._fileName);
        }
        this.context.setVariable(this._var.isEmpty() ? "org.apache.poi.hssf.usermodel.HSSFWorkbook" : this._var, _hssfWorkBook);
        
        invokeBody(output);
    }

    public void setFileName(String fileName)
    {
        this._fileName = fileName;
    }

    public void setVar(String var)
    {
        this._var = var;
    }

}
