package com.ggreiff.gel.tag.xls;

import org.apache.commons.jelly.JellyTagException;
import org.apache.commons.jelly.TagSupport;
import org.apache.commons.jelly.XMLOutput;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: ggreiff
 * Date: 3/10/14
 * Time: 8:54 AM
 */
public class XlsSheetTag extends TagSupport {
    private static final Log log = LogFactory.getLog(XlsSheetTag.class);

    private String _var = "";
    private String _sheetName = "";
    private HSSFWorkbook _hssfWorkBook;
    private HSSFSheet _hssfSheet;


    public XlsSheetTag() {
    }

    public void doTag(XMLOutput output) throws JellyTagException {

        if (this._hssfWorkBook == null) {
            if (this.context.getVariables().containsKey("org.apache.poi.hssf.usermodel.HSSFWorkbook"))
                this._hssfWorkBook = (HSSFWorkbook) this.context.getVariable("org.apache.poi.hssf.usermodel.HSSFWorkbook");
        }

        if (this._hssfWorkBook == null) {
            log.error("Could not load xls file");
            throw new JellyTagException("Sheet needs a workbook to execute on");
        }

        if (this._sheetName.isEmpty()) {
            int i = 1;
            while (true) {
                this._sheetName = "Sheet-" + i;
                if (!sheetExists(this._sheetName)) {
                    this._hssfSheet = _hssfWorkBook.createSheet(_sheetName);
                    break;
                }
            }
        } else {
            if (sheetExists(_sheetName)) {
                this._hssfSheet = _hssfWorkBook.getSheet(_sheetName);
            } else {
                this._hssfSheet = _hssfWorkBook.createSheet(_sheetName);
            }
        }
        this.context.setVariable(this._var.isEmpty() ? "org.apache.poi.hssf.usermodel.HSSFSheet" : this._var, this._hssfSheet);

        invokeBody(output);
    }

    public void setSheetName(String sheetName) {
        this._sheetName = sheetName;
    }

    public void setVar(String var) {
        this._var = var;
    }

    public void setWorkBook(HSSFWorkbook workBook) {
        this._hssfWorkBook = workBook;
    }

    private Boolean sheetExists(String sheetName) {
        List<String> sheetNames = getSheetNames();
        return sheetNames.contains(sheetName);
    }

    private List<String> getSheetNames() {
        List<String> sheetNames = new ArrayList<String>();
        for (int i = 0; i < _hssfWorkBook.getNumberOfSheets(); i++) {
            sheetNames.add(_hssfWorkBook.getSheetName(i));
        }
        return sheetNames;
    }
}
